/*
Announcements:
    - Upcoming programs
        - P9 due thursday
        - P10 Thursday --> Thursday
        - P11 Thursday --> Thursday @ 1:00pm
    - Final exam!
*/






public class ClassesDay2{
    public static void main(String[] args){
        
        /////////////////////
        // EX: setting GPA //
        /////////////////////

        // Student linda = new Student("Linda Ashford");
        // Student scott = new Student("Scott McGee");

        // linda.gpa = 3.9;
        // scott.gpa = -5.0;
        // System.out.println(linda.gpa);
        // System.out.println(scott.gpa);

        // solution? "set" method!
        // (Sam, go uncomment it)
        // linda.setGPA(3.9);
        // scott.setGPA(-5);
        // System.out.println(linda.gpa);
        // System.out.println(scott.gpa);

        //////////////////////////////////////////////

        // problem? can still change it directly...
        // scott.setGPA(-5);
        // System.out.println(scott.gpa);
        // scott.gpa = -1000;
        // System.out.println(scott.gpa);

        // solution: make gpa "private"? 
        // (Sam, go do this.)
        // (Sam, explain "private")
        // scott.setGPA(-5); // this works still
        // scott.gpa = -1000; // can't do this anymore!!!


        //////////////////////////////////////////////

        // problem: can't "get" it now...
        // scott.setGPA(-5);
        // System.out.println(scott.gpa);

        // solution: write a method to "get" it
        // (Sam, go uncomment it)
        // scott.setGPA(-5);
        // System.out.println(scott.getGPA());

        //////////////////////////////////////////////

        //////////////////////
        // Access modifiers //
        //////////////////////

        // Sam: explain private/public/default

        ////////////////////////////////////////////

        // EXAMPLE
        // Q: which of the following lines will be an error?
        // Example1 ex = new Example1();

        // ex.x = 5;
        // ex.name = "John";

        // ex.y = 100;
        // ex.title = "Doctor";

        // ex.z = 11;
        // ex.secret = "Not a real doctor";

        ////////////////////////////////////////////

        // methods can have access modifiers too!
        // Example1 ex = new Example1();

        // Q: which of the following lines will be errors?
        // (Sam, uncomment the methods...)
        // System.out.println(ex.getZ());
        // System.out.println(ex.getSecret());

        // Q: which of the following lines will be errors?
        // (Sam, uncomment the SECRET methods...)
        // ex.superSecret();
        // ex.doSomethingSecret();

        ////////////////////////////////////////////

        // General paradigm: 
        // - instance variables are private
        //   - use "getters" and "setters"
        // - methods are public

        // see "Example2.java"
        // Example2 ex = new Example2();
        // ex.setHeight();
        
        ////////////////////////////////////////////

        ///////////////////////////
        // EX: student ID number //
        ///////////////////////////

        // problem: want ID number to be UNIQUE...
        // Student2 linda = new Student2("Linda Ashford", 2);
        // Student2 scott = new Student2("Scott McGee", 2);
        // System.out.println(linda.id);
        // System.out.println(scott.id);


        // solution: use setter?
        // ...

        // issue: need information to be retained across
        //        ALL instances of the Student2 class...
        // Solution: Need a variable that EVERY 
        //           Student2 has access to!

        ////////////
        // static //
        ////////////

        // Idea: a single variable is shared across ALL instances
        // Sam: draw in the diagram

        // can be access using
        // instanceName.varName
        // OR ClassName.varName




        ////////////////////////
        // fixing the example //
        ////////////////////////

        // Sam: uncomment in Student 2 class

        // Student2 linda = new Student2("Linda Ashford");
        // System.out.println( Student2.count );
        // Student2 scott = new Student2("Scott McGee");
        // System.out.println( Student2.count );

        // System.out.println(linda.id);
        // System.out.println(scott.id);

        ////////////////////////////////////////////

        // // EXAMPLE
        // Example3 first = new Example3(10.1);
        // Example3 second = new Example3(-5.5);

        // System.out.println(first.getY());
        // System.out.println(second.getY());

        // System.out.println(Example3.getX());

        // Example3.x = 10;

        // System.out.println(Example3.getX());

        // second.x = 1000;

        // System.out.println(Example3.getX());





        ////////////////////////////////////////////

        // EXAMPLE 4: on your own
        // Example4 first = new Example4(5);
        // System.out.println(Example4.id);
        // System.out.println(first.z);
        // Example4 second = new Example4(2);
        // System.out.println(first.id);
        // System.out.println(first.z);
        // first.printSomethingNice();

        ////////////////////////////////////////////

        // Example 4b: no instances? 
        // System.out.println(Example4.id);
        // Example4.id = 0;
        // System.out.println(Example4.id);

        // Example4.printSomethingNice();




        /////////////////
        // OVERLOADING //
        /////////////////

        // Example5 ex = new Example5();

        // ex.setX();
        // System.out.println(ex.x);
        // ex.setX(10);
        // System.out.println(ex.x);
        // ex.setX(3.5);
        // System.out.println(ex.x);

        ////////////////////////////////////////////

        // moral of the story:
        // allowed to define multiple functions with the same name
        // IF their input type order is different

        // applies to constructors too!
        // Example5 first = new Example5();
        // System.out.println(first.x);

        // Example5 second = new Example5(15);
        // System.out.println(second.x);

        // Example5 third = new Example5(true, 1);
        // System.out.println(third.x);

    }
}

